/* Wuxi Book V02 Loe (c) december 2011 */
/* tool to copy esher style line fragments */
import processing.pdf.*;

int XSIZE=900;
int YSIZE=900;
PGraphics pdf;
Terrapin t;
PImage b;
void setup(){
  size(XSIZE,YSIZE);
  background(51);
  b = loadImage("laDefense.jpg");
  image(b, 0, 0);
  stroke(0,255,0);
  t = new Terrapin(this);
  t.drawing=true;
  t.setPenColor(255, 0, 0);
  pdf=beginRecord(PDF, "everything.pdf"); 
  println("move mouse and click at successive interesting points");
}


void draw() {
    pdf.flush();
}
void stop(){
  endRecord();
  pdf.flush();
}

float prevMouseX = -77;
float prevMouseY = -77;
float prevTheta  = 0;

float mynf(float x){
      //get rid of too many decimals
      return float(int(10*x))/10;
}

void mouseClicked() {
     if (prevMouseX == -77 && prevMouseY == -77) {
         prevMouseX = mouseX; prevMouseY = mouseY; println("//let's begin..");
         t.setLocation(mouseX,mouseY);
     }
     else {
         float dx = mouseX - prevMouseX;
         float dy = mouseY - prevMouseY;
         float forwd  = int(sqrt(dx*dx + dy*dy));
         float theta = (atan2(-dy,dx) * 180)/PI;
         float dTheta = theta - prevTheta;
         if (dTheta < -240) dTheta += 360;
         if (dTheta >  240) dTheta -= 360;
         print("t.left(");print(mynf(dTheta));println(");");
         print("t.forward(");print(mynf(forwd));println(");");
         prevMouseX = mouseX; prevMouseY = mouseY;prevTheta = theta;
         t.left(dTheta);
         t.forward(forwd);
     }
}


